# saga::cpr Namespace Reference

The Checkpoint and Recovery (CPR) API package. More...

## Classes
class | checkpoint
| The saga::replica class implements the saga::attributes interface. More...
class | directory
| A checkpoint directory contains, you guess it, checkpoints. More...
class | job
| The job is a saga::job with additional checkpoint and recovery related methods. More...
class | description
| This object encapsulates all the attributes which define a job to be run. More...
class | self
| The job_self class is a job which represents the current application. More...
class | service
| The cpr::service, as a job::service, represents a resource management backend, which additionally offers checkpoint management capabilities. More...
## Namespaces
namespace | metrics
| Available metrics defined for the CPR API package.

namespace | attributes
| Available attributes defined for the CPR API package.

## Enumerations
enum | flags { None = saga::name_space::None, Overwrite = saga::name_space::Overwrite, Recursive = saga::name_space::Recursive, Dereference = saga::name_space::Dereference, Create = saga::name_space::Create, Exclusive = saga::name_space::Exclusive, Lock = saga::name_space::Lock, CreateParents = saga::name_space::CreateParents, Truncate = 128, Append = 256, Read = 512, Write = 1024, ReadWrite = Read | Write }
| The flags enum is inherited from the namespace package. More...
enum | state { Unknown = saga::job::Unknown, New = saga::job::New, Running = saga::job::Running, Failed = saga::job::Failed, Done = saga::job::Done, Canceled = saga::job::Canceled, Suspended = saga::job::Suspended, Checkpointing = 6, Recovering = 7 }
| The state is equivalent to the inherited saga::job::state, but adds the Checkpointing and Recovering state. More...

## Detailed Description

The Checkpoint and Recovery (CPR) API package.

## Enumeration Type Documentation

enum saga::cpr::flags

The flags enum is inherited from the namespace package.

A number of cpr specific flags are added to it. All added flags are used for the opening of checkpoint and checkpoint directory instances, and are not applicable to the operations inherited from the namespace package.

Enumerator:

  None |
  Overwrite |
  Recursive |
  Dereference |
  Create |
  Exclusive |
  Lock |
  CreateParents |
  Truncate |
  Append |
  Read |
  Write |
  ReadWrite |

enum saga::cpr::state

The state is equivalent to the inherited saga::job::state, but adds the Checkpointing and Recovering state.

Checkpointing identifies a job instance which is in the process of checkpointing.

Recovering identifies a job instance which is in the process of recovering.

Enumerator:

  Unknown |
  New |
  Running |
  Failed |
  Done |
  Canceled |
  Suspended |
  Checkpointing |
  Recovering |